#!/bin/sh
# fractal
# Written in 2020 by Lucas
# CC0 1.0 Universal/Public domain - No rights reserved
#
# To the extent possible under law, the author(s) have dedicated all
# copyright and related and neighboring rights to this software to the
# public domain worldwide. This software is distributed without any
# warranty. You should have received a copy of the CC0 Public Domain
# Dedication along with this software. If not, see
# <http://creativecommons.org/publicdomain/zero/1.0/>.
usage()
{
	printf "Usage: %s width height [fractal args...]\n" "${0##*/}" >&2
	exit 1
}

tonumber()
{
	printf "%u\n" "$*"
}

width=
height=
if [ $# -lt 2 ] || ! width=$(tonumber "$1") || ! height=$(tonumber "$2"); then
	usage
fi
shift 2

upwidth=$((width * 4))
upheight=$((height * 4))
./fractal "$@" -w $upwidth -h $upheight |
    pamscale -width $width -height $height |
    pamtopng >julia.png
